#!/usr/bin/python

import auparse
import dbus
import dbus.service
import dbus.glib
import sys
import syslog

from dbus.mainloop.glib import DBusGMainLoop

class DBUS_mac_status(dbus.service.Object):
    def __init__(self):
        bus_name = dbus.service.BusName('org.selinux.mac_status', bus=dbus.SystemBus())
        dbus.service.Object.__init__(self, bus_name, '/org/selinux/mac_status')

    @dbus.service.signal('org.selinux.mac_status')
    def changed(self, mac_status):
        # syslog.syslog(syslog.LOG_WARNING, mac_status)
        pass


def handle_event(au, cb_event_type,user_data):
    # syslog.syslog(syslog.LOG_WARNING, au.find_field("enforcing"))
    if cb_event_type != auparse.AUPARSE_CB_EVENT_READY:
    	# syslog.syslog(syslog.LOG_WARNING, "not ready")
        return
    # syslog.syslog(syslog.LOG_WARNING, "ready")
    if au.get_type() == 1404:
        if (au.find_field("enforcing") == "1"):
            m.changed("Enforcing")
        else:
            m.changed("Permissive")

if __name__ == "__main__":
    # syslog.openlog("mac_status", 0, syslog.LOG_DAEMON)
    
    par = auparse.AuParser(auparse.AUSOURCE_FEED)
    par.add_callback(handle_event)

    m = DBUS_mac_status()
    line = sys.stdin.readline()
    while line:
        par.feed(line) 
        par.flush_feed()
        line = sys.stdin.readline()



